<template>
<v-container fluid>
    <v-row>
        <h2>
            Choose your floor:
        </h2>
    </v-row>
    <v-row>
    <v-select
    v-model="selectedFloor"
    :items="floors"
    item-text="name"
    label="Choose a floor"
    return-object
    outlined
    v-on:change="changeFloors"
    solo>
    </v-select>
    </v-row>
    <v-row>
        <room-bar 
        :listView="listView"
        @show-list-click="listView = true"
        @show-map-click="listView = false"
        ></room-bar>
    </v-row>
        <v-row v-if="selectedFloor&&listView">
            <room-list :room="room" v-for="room in rooms" :key="room.id" @room-click="onGotoRoom" @update-room="updateRoom"></room-list>
        </v-row>
    <v-row v-if="selectedFloor&&!listView" class="holder">
        <room-plan :room="room" v-for="room in rooms" :key="room.id" @room-click="onGotoRoom" @update-room="updateRoom"></room-plan>
    </v-row>
    <v-snackbar v-model="errorInfo.showError" color="error">
        {{ errorInfo.errorMessage }}
    </v-snackbar>
</v-container>
</template>

<style scoped>
.holder{
    position: relative;
    width:100%;
    height:1100px;
    overflow-y: visible;
}
@media screen and (max-width: 1500px){
    .holder{
        overflow-x:scroll;
    }
}
</style>

<script>
import FloorService from "@/services/FloorService";
import RoomService from "@/services/RoomService";
import RoomPlan from "@/components/RoomPlan";
import RoomBar from "@/components/RoomBar";
import RoomList from "@/components/RoomList";

export default {
    name: "Floors",
    components: {   
        RoomPlan,
        RoomBar,
        RoomList
    },
    data: () => ({
        floors: [],
        listView: true,
        selectedFloor: null,
        rooms:null,
        polling:null,
        errorInfo: {
            showError: false,
            errorMessage: "",
        }
    }),
    async created(){
        await this.checkLoggedIn();
        await this.pollData();
        await this.loadFloors();
        await this.loadSelectedFloor();
        await this.loadRooms();
    },
    beforeMount(){
        this.checkLoggedIn()
    },
    methods: {
    loadFloors() {
    return FloorService.get()
        .then((floors) => {
            this.floors = floors;
         })
        .catch((error) => {
            this.handleError("Loading floors failed",error);
         });
    },
    updateRoom(room){
        RoomService.put(room)
        .catch((error) => {
            console.log(error);
        })
    },
    pollData(){
        this.polling = setInterval(() =>{
                RoomService.getByFloorId(this.selectedFloor.id).then((rooms) => {
                this.rooms = rooms
            }).catch((error) => {
                console.log(error);
            })
        },3000)
    },
    loadSelectedFloor(){
        return FloorService.getById(1)
        .then((floor) =>{
            this.selectedFloor = floor;
            if(this.$router.currentRoute.name != 'Floor'){
            this.$router.push({ name: "Floor", params: {floorId: this.selectedFloor.id}})
            }
        })
        .catch((error) => {
            console.log(error);
        })
    },
    loadRooms(){
        return RoomService.getByFloorId(this.selectedFloor.id).then((rooms) => {
            this.rooms = rooms
        }).catch((error) => {
            console.log(error);
        })
    },
    changeFloors(){
        RoomService.getByFloorId(this.selectedFloor.id).then((rooms)=>{
            this.rooms = rooms
        }).then(this.$router.push({ name: "Floor", params: {floorId: this.selectedFloor.id }}))
    },
    onGotoRoom(room){
        this.$router.push({ name: "roomName", params: {floorId: this.selectedFloor.id ,roomName: room.name }})
    },
    handleError(userMessage, error){
        this.errorInfo.errorMessage = userMessage;
        this.errorInfo.showError = true;
        console.log(error);
    },
    checkLoggedIn(){
        if(!localStorage.getItem('loggedIn')){
            this.$router.push({ name: "Login"})
        }
    }
    }  
}
</script>